#! /usr/bin/perl

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use Math::Trig;

my $tooth_width = 3;
my $tooth_depth = 2.5;
my $center_hole = 3;
my $router_diameter = -1.5;
my $disc_diameter = 0;
my $temp_d = 0;
my $factor = 100;
my $teeth = 26;
my $i;
my $alpha = 0.0;
my $alpha_plus = 0.0;
my $PI = 3.1415927;
my $x = 0.0;
my $y = 0.0;

open(FILEOUT,'> pictures/sensorwheel.svg') || die "Can not open" . "pictures/sensorwheel.svg!\n";

  print FILEOUT "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\"><svg version=\"1.1\" viewBox=\"0 0 21000 29700\" preserveAspectRatio=\"xMidYMid\" fill-rule=\"evenodd\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\"><g visibility=\"visible\" id=\"Default\"><desc>Master slide</desc><g style=\"stroke:none;fill:none\"><rect x=\"-14\" y=\"-14\" width=\"21030\" height=\"29730\"/></g></g><g visibility=\"visible\" id=\"page1\"><desc>Slide</desc><g><desc>Drawing</desc><g><g style=\"stroke:rgb(0,0,0);fill:none\">";


  print FILEOUT "<path style=\"fill:none\" d=\"M ";

  for($alpha = 0.0; $alpha < 2.0 * $PI; $alpha+=0.05){
    $x = sin($alpha) * ($center_hole - $router_diameter) / 2.0;
    $y = cos($alpha) * ($center_hole - $router_diameter) / 2.0;

    $x = int($x * $factor);
    $y = int($y * $factor);
    print FILEOUT " " . $x . "," . $y . " ";
  }
  $x = int(sin(0.0) * ($center_hole - $router_diameter) * $factor) / 2.0;
  $y = int(cos(0.0) * ($center_hole - $router_diameter) * $factor) / 2.0;
  print FILEOUT " " . $x . "," . $y . " ";

  print FILEOUT "\"/></g><g/></g></g><g><desc>Drawing</desc><g><g style=\"stroke:rgb(0,0,0);fill:none\"><path style=\"fill:none\" d=\"M ";

  $disc_diameter = $tooth_width * $teeth / $PI;

  $i = 0;
  $alpha_plus = asin($router_diameter/$disc_diameter);
  for($alpha = 0.0; $alpha < 2.0 * $PI; $alpha+=0.005){
    if($alpha - $alpha_plus > $i * ($PI / $teeth)){
      $i++;
      if($temp_d == 0){
        $temp_d = $tooth_depth;
        $alpha_plus = 0.0;
      }
      else{
        $temp_d = 0.0;
        $alpha_plus = asin($router_diameter/$disc_diameter);
      }
    }
    $x = int(sin($alpha) * ($disc_diameter + $router_diameter - $temp_d) * $factor);
    $y = int(cos($alpha) * ($disc_diameter + $router_diameter - $temp_d) * $factor);

    print FILEOUT " " . $x . "," . $y . " ";
  }
  $x = int(sin(0.0) * ($disc_diameter + $router_diameter - $temp_d) * $factor);
  $y = int(cos(0.0) * ($disc_diameter + $router_diameter - $temp_d) * $factor);
  print FILEOUT " " . $x . "," . $y . " ";



  print FILEOUT "\"/></g><g/></g></g></g></svg>";


close(FILEOUT);
